/*
ColonYen Version 1.13
Starting the Command Prompt window
Copyright 2016-2020 Sogaya

Borland C++ 5.5.1 for Win32

*/

#define UM_TIME_START (WM_APP + 1) 
#include "ColonYen.h"

namespace {
    char HELP_FILE_NAME[] = "C:\\ColonYen\\ColonYen.pdf";
    char SLOW_TEXT[] = "C:\\ColonYen\\slow.txt";
    char TITLE_BAR[P_SIZE];
    char WINDOW_NAME[] = "ColonYen";
    char WINDOWS_XP_PRO_TEXT[] = "C:\\ColonYen\\XP_PRO.txt";
    const BOOL REPAINT = TRUE;
    const bool VERSION_WITH_COMMENTS = true;
    const bool VERSION_WITHOUT_COMMENTS = false;
    const int B_SIZE_1 = B_SIZE - 1;
    const int C_SIZE_1 = C_SIZE - 1;
    const int DELAYED = 1200;
    const int DETERMINED_BY_WINDOWS = 300;
    const int DIAGONAL = 3;
    const int HIDDEN = 0;
    const int LISTING_PERIOD = 300; // milliseconds
    const int LOWER_LIMIT = 21;
    const int MAIN_HEIGHT = 203;
    const int MAIN_WIDTH = 289;
    const int MAIN_X = 368;
    const int MAIN_Y = 283;
    const int MS_DOS = 0;
    const int NON_SAMPLING_PERIOD = 500; // milliseconds
    const int NOT_FOUND = -1;
    const int ONE_SECOND = 1000; // milliseconds
    const int SHORT_SLEEP = 600;
    const int SLOW_TEXT_LINE_COUNT = 4;
    const int TEXT_AREA_HEIGHT = 87;
    const int TEXT_AREA_TOP = 107;
    const int TEXT_AREA_WIDTH = 289;
    const int TRIMMING = 1;
    const int UPPER_LIMIT = 2100000000;
    const int VARIABLE_RATIO = 0;
    const int WINDOWS_10 = 100;
    const int WINDOWS_7 = 61;
    const int WINDOWS_VISTA = 60;
    const int WINDOWS_XP = 51;
    const int WINDOWS_XP_HOME = 512;
    const std::string BLACK_BACKGROUND_WHITE_CHARACTERS("/T:0F");
    const std::string C_TASKLIST_FINDSTR_CMD_EXE_1 = "/C C:\\ColonYen\\CMD_PID1.bat";
    const std::string C_TASKLIST_FINDSTR_CMD_EXE_2 = "/C C:\\ColonYen\\CMD_PID2.bat";
    const std::string CMD_EXE("cmd.exe");
    const std::string GAP_S(" ");
    const std::string TASKKILL_PID = "/C TASKKILL /PID ";
    const unsigned char GAP_BYTE = 32;
    const unsigned char NONGAP_BYTE = 33; // GAP_BYTE + 1

    bool depressed, kill_CMD, show_where, start_help;
    bool locating_mode = false;
    bool not_automatically = true;
    char specified[C_SIZE];
    double VERSION_NUMBER = 1.13;
    HINSTANCE hInstance;
    HWND console_window_handle, hwnd, textArea;
    int bar_estimate = VARIABLE_RATIO;
    int buffer_size = DETERMINED_BY_WINDOWS;
    int console_height = 677;
    int console_width = 492;
    int delay = ONE_SECOND;
    int maximum_delay = DELAYED;
    int edge_estimate = VARIABLE_RATIO;
    int first_list_of_IDs[A_SIZE] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
    int hidden_pane = HIDDEN;
    int locating_cycle = NON_SAMPLING_PERIOD;
    int main_height = MAIN_HEIGHT;
    int main_width = MAIN_WIDTH;
    int main_x = MAIN_X;
    int main_y = MAIN_Y;
    int nap = SHORT_SLEEP;
    int OS_ID[11][10];
    int second_list_of_IDs[A_SIZE] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
    int session = 1;
    int standard_main_x = MAIN_X;
    int standard_main_y = MAIN_Y;
    int terminating_cycle = LISTING_PERIOD;
    int version_of_OS;
    int which_corner = DIAGONAL;
    std::string exe = CMD_EXE;
    std::string operand = BLACK_BACKGROUND_WHITE_CHARACTERS;
}

bool startDepressed() {
    const int BORDER = 4;
    const int BUTTON_HEIGHT = 27;
    const int BUTTON_LEFT = 213;
    const int BUTTON_TOP = 68;
    const int BUTTON_WIDTH = 65;
    const int HEAD = 40;
    POINT pos;
    RECT windowRect;

    ::GetWindowRect(hwnd, &windowRect);
    ::GetCursorPos(&pos);

    int upper_left_x = windowRect.left + BUTTON_LEFT + BORDER;
    int upper_left_y = windowRect.top + HEAD + BUTTON_TOP + BORDER;
    int upper_right_x = upper_left_x + BUTTON_WIDTH;
    int lower_left_y = upper_left_y + BUTTON_HEIGHT;
    bool inside = false;
    if( upper_left_x < pos.x && pos.x < upper_right_x ) {
        if( upper_left_y < pos.y && pos.y < lower_left_y ) {
            inside = true;
        }

    }

    return inside;
}

bool startHandler() {
    bool taskCompleted;

    ::SetCurrentDirectory(specified);
    executeProgram(exe, operand);

    taskCompleted = centeringSmallConsole(hidden_pane);
    if( show_where ) {
        taskCompleted = false;
    }

    closing(taskCompleted);
    return taskCompleted;
}

int WINAPI WinMain(HINSTANCE instance, HINSTANCE hPrevInst, LPSTR lpszArgs, int nWinMode) {
    using namespace std;

    char *p[S_SIZE];
    char *stop;
    char buffer[B_SIZE];
    int B_SIZE_1 = B_SIZE - 1;
    int bufferLength, count, exe_name_length, item_count, quoted_operand_length, tab;
    int many_fields = P_SIZE;
    int slow_number[SLOW_TEXT_LINE_COUNT];
    OSVERSIONINFO osvi;
    string exe_name, g, quoted_operand, s;

// Checking if software can open SLOW_TEXT
    try {
        ifstream slowFile(SLOW_TEXT);
        slowFile.exceptions(ios_base::failbit);

        count = 0;
        while( slowFile.getline(buffer, B_SIZE) ) {
            tab = strcspn(buffer, "#\s\t");// 23h, 20h, 09h
            if( tab < strlen(buffer) ) {
                buffer[tab] = '\0';
            }

            slow_number[count] = (int)strtol(buffer, &stop, 10);
            count += 1;
            if( count >= SLOW_TEXT_LINE_COUNT ) {
                break;
            }

        }

        maximum_delay = slow_number[0];
        locating_cycle = slow_number[1];
        terminating_cycle = slow_number[2];
        nap = slow_number[3];
    } catch(...) {
        ;
    }

// Checking the version of OS
    OS_ID[0][0] = MS_DOS;
    OS_ID[5][1] = WINDOWS_XP;
    OS_ID[6][0] = WINDOWS_VISTA;
    OS_ID[6][1] = WINDOWS_7;
    OS_ID[10][0] = WINDOWS_10;

    osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
    ::GetVersionEx( &osvi );
    version_of_OS = OS_ID[osvi.dwMajorVersion ][osvi.dwMinorVersion];

    if( version_of_OS == WINDOWS_XP ) {
        ifstream xpFile(WINDOWS_XP_PRO_TEXT);
        if( xpFile.fail() ) {
            version_of_OS = WINDOWS_XP_HOME;
        }

    }

// Dividing the command line into many parameters
    buffer[B_SIZE_1] = '\0';
    strncpy(buffer, ::GetCommandLine(), B_SIZE_1);
    bufferLength = strlen(buffer);
/*
colonyen  -t1000 -W580 -H390 -o "/T:0F" 
0123456789012345678901234567890
*/
    buffer[8] = NONGAP_BYTE;

    FieldsList *f = new FieldsList();
    DividingSJIS *d = new DividingSJIS(GAP_BYTE);
    d->setting(f, many_fields);

    d->mapping_fields_list(buffer, bufferLength);
    item_count = f->itemCount();
    for(int n = 0; n < item_count; ++n) {
        g = f->item(n);
        p[n] = new char[P_SIZE];
        strcpy(p[n], g.c_str() );
    }

// Evaluating parameters
    ParameterList *listing = new ParameterList(item_count, p);
    HyphenTerms *h = new HyphenTerms(listing);
    h->setting();

    if( h->guideFile() ) {
        Guiding *g = new Guiding();
        g->versionGuide(VERSION_NUMBER, VERSION_WITH_COMMENTS);
        delete g; delete h;
        exit(1);
    } else if( h->versionNumber() ) {
        Guiding *g = new Guiding();
        g->versionGuide(VERSION_NUMBER, VERSION_WITHOUT_COMMENTS);
        delete g; delete h;
        exit(1);
    }

    if( version_of_OS == WINDOWS_XP_HOME ) {
        kill_CMD = false;
    } else {
        kill_CMD = h->killCMD();
    }

    quoted_operand = h->listName(1);
    quoted_operand_length = quoted_operand.length();
    if( quoted_operand_length == 0 ) {
        quoted_operand = h->quotedOperand();
    }

    exe_name = h->listName(2);
    exe_name_length = exe_name.length();
    if( exe_name_length == 0 ) {
        exe_name = h->exeName();
    }

    delay = ( maximum_delay < h->waitingTime() ) ? maximum_delay : h->waitingTime();

    FinalEffects *e = new FinalEffects(exe_name, h->pathName(), quoted_operand, 
        h->barEstimate(), h->bufferSize(), h->consoleHeight(), h->consoleWidth(), h->edgeEstimate(), h->errorLevel(), h->hiddenPane(), h->whichCorner(), delay, 
        kill_CMD, h->notAutomatically(), h->showWhere(), h->startHelp(), h->titleVersion() );

    bar_estimate = e->barEstimate();
    buffer_size = e->bufferSize();
    console_height = e->consoleHeight();
    console_width = e->consoleWidth();
    edge_estimate = e->edgeEstimate();
    exe = e->exeName();
    hidden_pane = e->hiddenPane();
    kill_CMD = e->killCMD();
    not_automatically = e->notAutomatically();
    operand = e->quotedOperand();
    show_where = e->showWhere();
    start_help = e->startHelp();
    delay = e->waitingTime();
    which_corner = e->whichCorner();

    s = e->pathName();
    specified[C_SIZE_1] = '\0';
    strncpy(specified, s.c_str(), C_SIZE_1);

// Checking if software can open essential files
    ProvideFiles *u = new ProvideFiles(specified);
    if( u->setting() ) {
        return 0; // error
    }

// title bar
    if( e->titleVersion() ) {
        string s;
        stringstream os;
        os << WINDOW_NAME << GAP_S << VERSION_NUMBER;
        s = os.str();
        strcpy(TITLE_BAR, s.c_str() );
    } else {
        strcpy(TITLE_BAR, WINDOW_NAME);
    }

    ProduceBatch *r = new ProduceBatch(bar_estimate, edge_estimate, buffer_size, version_of_OS, console_height, console_width);

    if( r->setting() ) { // If the user add -b10 or -e23 to the colonyen command, the height-to-width ratio is constant, not variable.
        console_height = r->consoleHeight();
        console_width = r->consoleWidth();
    }

    delete r;
    delete e;
    delete h;
    delete listing;

    for(int n = 0; n < item_count; ++n) {
        delete p[n];
    }

    delete d;
    delete f;

// Creatring a window
    MSG msg;
    WNDCLASSEX wcl;
    HACCEL hAccel;

    wcl.cbSize = sizeof(WNDCLASSEX);

    wcl.hInstance = instance;
    wcl.lpszClassName = WINDOW_NAME;
    wcl.lpfnWndProc = WindowFunc;
    wcl.style = 0;

    wcl.hIcon = ::LoadIcon(instance, "ColonYenIcon");
    wcl.hIconSm = NULL;
    wcl.hCursor = ::LoadCursor(NULL, IDC_ARROW);

    wcl.lpszMenuName = "ColonYenMenu";
    wcl.cbClsExtra = 0;
    wcl.cbWndExtra = 0;

    wcl.hbrBackground = (HBRUSH) ::GetStockObject(WHITE_BRUSH);

    if(! ::RegisterClassEx(&wcl) ) {
        return 0; // error
    }

    int windowStyle = WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU;
    main_width = MAIN_WIDTH;
    main_height = MAIN_HEIGHT;
    standard_main_x = MAIN_X;
    standard_main_y = MAIN_Y;
    hwnd = ::CreateWindow(
        WINDOW_NAME,
        TITLE_BAR, 
        windowStyle, 
        standard_main_x, 
        standard_main_y, 
        main_width, 
        main_height, 
        NULL, 
        NULL, 
        instance, 
        NULL
    );

    hInstance = instance;

    hAccel = ::LoadAccelerators(instance, "ColonYenMenu");

    switch(which_corner) {
    case 1:
        cornerHandler(hwnd);
        break;
    case 2:
        rightHandler(hwnd);
        break;
    case 3:
        diagonalHandler(hwnd);
        break;
    case 4:
        underHandler(hwnd);
        break;
    default:
        centering(hwnd);
        break;
    }

    ::ShowWindow(hwnd, nWinMode);
    ::UpdateWindow(hwnd);

    while( ::GetMessage(&msg, NULL, 0, 0) ) {
        if(! ::TranslateAccelerator(hwnd, hAccel, &msg) ) {
            ::TranslateMessage(&msg);
            ::DispatchMessage(&msg);
        }

    }

    return msg.wParam;
}

LRESULT CALLBACK WindowFunc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam) {
    const bool TASK_COMPLETED = true;
    HBITMAP hBitmap;
    HDC hdc, memdc;
    PAINTSTRUCT paintStruct;
    std::string label = exe + GAP_S + operand;

    switch(message) {
    case UM_TIME_START:
        if( start_help ) {
            executeProgram(HELP_FILE_NAME, "");
            closing(TASK_COMPLETED);
        } else {
            startHandler(); // timer
        }

        break;
    case WM_CHAR:
        switch( (char)wParam ) {
        case '-':
            startHandler(); // keyboard
            break;
        }

        break;
    case WM_COMMAND:
        switch( LOWORD(wParam) ) {
        case IDM_CLOSE:
            closing(TASK_COMPLETED);
            break;
        case IDM_ESCAPE:
            locating_mode = false;
            break;
        case IDM_HELP:
            helpHandler(wParam);
            break;
        case IDM_START:
            startHandler(); // menu
            break;
        case IDM_TERMINATE:
            if( version_of_OS != WINDOWS_XP_HOME ) {
                ::SetTimer(hwnd, IDM_TERMINATE_TIMER, terminating_cycle, (TIMERPROC)terminateHandler);
            }

            break;
        }

        break;
    case WM_CREATE:
        textArea = ::CreateWindow(
            "STATIC",
            "",
            WS_CHILD | WS_VISIBLE | SS_LEFT,
            0, TEXT_AREA_TOP, TEXT_AREA_WIDTH, TEXT_AREA_HEIGHT,
            hwnd,
            (HMENU)IDM_LABEL,
            hInstance,
            NULL
        );

        ::SetWindowText(textArea, label.c_str() );

// Updating
        layout();
        depressed = false;

        if(! not_automatically ) {
            ::SetTimer(hwnd, IDM_TIMER, delay, (TIMERPROC)TimerProc);
        }

        if( show_where ) {
            ::SetTimer(hwnd, IDM_SHOW_WHERE_TIMER, locating_cycle, (TIMERPROC)showWhereCursor);
            locating_mode = true;
        }

        if( kill_CMD ) {
            ::SetTimer(hwnd, IDM_TERMINATE_TIMER, terminating_cycle, (TIMERPROC)terminateHandler);
        }

        break;
    case WM_DESTROY:
        closing(TASK_COMPLETED);
        break;
    case WM_KEYUP:
        switch( (char)wParam ) {
        case VK_ESCAPE:
            locating_mode = false;
            break;
        case VK_F3:
            closing(TASK_COMPLETED);
            break;
        }

        break;
    case WM_LBUTTONDOWN:
        depressed = startDepressed();
        if( depressed ) {
            ::InvalidateRect(hwnd, NULL, TRUE);
        }

        break;
    case WM_LBUTTONUP:
        depressed = startDepressed();
         if( depressed ) {
            startHandler(); // button
            depressed = false;
        } else {
            ::InvalidateRect(hwnd, NULL, TRUE);
        }

        break;
    case WM_PAINT:
        if( depressed ) {
            hBitmap = ::LoadBitmap(hInstance, "startDepressed");
        } else {
            hBitmap = ::LoadBitmap(hInstance, "start");
        }

        hdc = ::BeginPaint(hwnd, &paintStruct);
        memdc = ::CreateCompatibleDC(hdc);
        ::SelectObject(memdc, hBitmap);

// Painting
        ::BitBlt(hdc, 0, 0, TEXT_AREA_WIDTH, TEXT_AREA_TOP, memdc, 0, 0, SRCCOPY);

        ::DeleteObject(hBitmap);
        ::EndPaint(hwnd, &paintStruct);
        ::DeleteDC(memdc);
        break;
    case WM_SIZE:
        layout();
        break;
    default:
        return ::DefWindowProc(hwnd, message, wParam, lParam);
    }

    return 0;
}

VOID CALLBACK showWhereCursor(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime) {
    bool through = false;
    char buffer[B_SIZE];
    const int BORDER = ::GetSystemMetrics(SM_CYSIZEFRAME);
    const int TITLE_BAR_HEIGHT = ::GetSystemMetrics(SM_CYCAPTION);
    const int MENU_HEIGHT = ::GetSystemMetrics(SM_CYMENU);
    const int HEAD = BORDER + TITLE_BAR_HEIGHT + MENU_HEIGHT;
    int upper_left_x, upper_left_y, upper_right_x, lower_left_y;
    POINT pos;
    RECT windowRect;

    if( locating_mode ) {
        ::GetWindowRect(hwnd, &windowRect);
        ::GetCursorPos(&pos);

        upper_left_x = windowRect.left;
        upper_left_y = windowRect.top + HEAD;
        upper_right_x = windowRect.right;
        lower_left_y = windowRect.bottom - BORDER;
        if( upper_left_x < pos.x && pos.x < upper_right_x ) {
            if( upper_left_y < pos.y && pos.y < lower_left_y ) {
                through = true;
            }

        }

        if( through ) {
            wsprintf(buffer, "%d : %d ( inside ) ", pos.x, pos.y);
        } else {
            wsprintf(buffer, "%d : %d ( outside ) ", pos.x, pos.y);
        }

        ::SetWindowText(hwnd, buffer);
    } else {
        ::KillTimer(hwnd, IDM_SHOW_WHERE_TIMER);
        ::SetWindowText(hwnd, WINDOW_NAME);
    }

}

VOID CALLBACK terminateHandler(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime) {
    using namespace std;

    const bool TASK_COMPLETED = true;
    int id;
    stringstream os;
    TerminateCMD *t = new TerminateCMD();

    exe = CMD_EXE;

    switch(session) {
    case 1:
        operand = C_TASKLIST_FINDSTR_CMD_EXE_1; // CMD_PID1
        executeProgram(exe, operand);
        break;
    case 2:
        operand = C_TASKLIST_FINDSTR_CMD_EXE_2; // CMD_PID2
        executeProgram(exe, operand);
        break;
    case 3:
        t->programID_1(first_list_of_IDs);
        t->programID_2(second_list_of_IDs);
        id = t->terminating(first_list_of_IDs, second_list_of_IDs);
        if( id > 0 ) {
            os << TASKKILL_PID << id;
            operand = os.str();
            executeProgram(exe, operand);
        }

        break;
    default:
        ::KillTimer(hwnd, IDM_TERMINATE_TIMER);
        closing(TASK_COMPLETED);
        break;
    }

    session += 1;
    delete t;
}

VOID CALLBACK TimerProc(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime) {
    ::KillTimer(hwnd, IDM_TIMER);
    ::PostMessage(hwnd, UM_TIME_START, (WPARAM)0, (LPARAM)0);
}

void centering(HWND hwnd) {
    const int HALF_WIDTH = main_width/2;
    const int HALF_HEIGHT = main_height/2;
    const int MENU_BAR_HEIGHT = ::GetSystemMetrics(SM_CYMENU);
    const int SCREEN_WIDTH = ::GetSystemMetrics(SM_CXFULLSCREEN);
    const int TITLE_BAR_HEIGHT = ::GetSystemMetrics(SM_CYCAPTION);
    int screen_height = ::GetSystemMetrics(SM_CYFULLSCREEN);
    screen_height += MENU_BAR_HEIGHT;
    screen_height += TITLE_BAR_HEIGHT;
    main_x = SCREEN_WIDTH/2 - HALF_WIDTH;
    main_y = screen_height/2 - HALF_HEIGHT;

    ::MoveWindow(hwnd, main_x, main_y, main_width, main_height, REPAINT);

    standard_main_x = main_x;
    standard_main_y = main_y;
}

bool centeringSmallConsole(int hidden_pane) {
    const bool TASK_IS_NOT_COMPLETED = false;
    const int HALF_WIDTH = console_width/2;
    const int HALF_HEIGHT = console_height/2;
    const int MENU_BAR_HEIGHT = ::GetSystemMetrics(SM_CYMENU);
    const int SCREEN_WIDTH = ::GetSystemMetrics(SM_CXFULLSCREEN);
    const int TITLE_BAR_HEIGHT = ::GetSystemMetrics(SM_CYCAPTION);
    int screen_height = ::GetSystemMetrics(SM_CYFULLSCREEN);
    screen_height += MENU_BAR_HEIGHT;
    screen_height += TITLE_BAR_HEIGHT;

    ::Sleep(nap);
    console_window_handle = ::FindWindow("ConsoleWindowClass", NULL);
    if( console_window_handle == 0 ) {
        return TASK_IS_NOT_COMPLETED;
    }

    ::ShowWindow(console_window_handle, SW_RESTORE);
    int console_x = SCREEN_WIDTH/2 - HALF_WIDTH;
    int console_y = screen_height/2 - HALF_HEIGHT;

    bool task_completed = true;
    switch(hidden_pane) {
    case 1:
        ::SetWindowPos(console_window_handle, HWND_BOTTOM, console_x, console_y, console_width, console_height, 0);
        ::ShowWindow(console_window_handle, SW_MINIMIZE);
        break;
    case 2:
        ::SetWindowPos(console_window_handle, HWND_BOTTOM, console_x, console_y, console_width, console_height, 0);
        break;
    case 3:
        ::SetWindowPos(console_window_handle, HWND_BOTTOM, console_x, console_y, console_width, console_height, SWP_HIDEWINDOW);
        task_completed = false;
        break;
    default:
        ::SetWindowPos(console_window_handle, HWND_TOP, console_x, console_y, console_width, console_height, 0);
        break;
    }

    return task_completed;
}

void closing(bool task_completed) {
    if( task_completed ) {
        ::PostQuitMessage(0);
    }

}

void cornerHandler(HWND hwnd) {
    which_corner = 1;

    main_x = 0;
    main_y = 0;
    ::MoveWindow(hwnd, main_x, main_y, main_width, main_height, REPAINT);
}

void diagonalHandler(HWND hwnd) {
    which_corner = 3;

    const int MENU_HEIGHT = ::GetSystemMetrics(SM_CYMENU);
    const int SCREEN_WIDTH = ::GetSystemMetrics(SM_CXFULLSCREEN);
    int screen_height = ::GetSystemMetrics(SM_CYFULLSCREEN);
    screen_height += MENU_HEIGHT;

    ::ShowWindow(hwnd, SW_RESTORE);

    main_x = SCREEN_WIDTH - main_width;
    main_y = screen_height - main_height;
    ::MoveWindow(hwnd, main_x, main_y, main_width, main_height, REPAINT);
}

void helpHandler(WPARAM wParam) {
    executeProgram(HELP_FILE_NAME, "");
}

void layout() {
    RECT windowRect;

    ::GetClientRect(hwnd, &windowRect);
    ::MoveWindow(textArea, 0, TEXT_AREA_TOP, windowRect.right, TEXT_AREA_HEIGHT, REPAINT);
}

void rightHandler(HWND hwnd) {
    which_corner = 2;

    const int SCREEN_WIDTH = ::GetSystemMetrics(SM_CXFULLSCREEN);

    ::ShowWindow(hwnd, SW_RESTORE);

    main_x = SCREEN_WIDTH - main_width;
    main_y = 0;
    ::MoveWindow(hwnd, main_x, main_y, main_width, main_height, REPAINT);
}

void executeProgram(const char *p, const char *q) {
    char FileName[S_SIZE];
    char Parameters[S_SIZE];
    strcpy(FileName, p);
    strcpy(Parameters, q);

    SHELLEXECUTEINFO execinfo;
    memset(&execinfo, 0, sizeof(execinfo) );
    execinfo.cbSize = sizeof(execinfo);
    execinfo.fMask = SEE_MASK_NOCLOSEPROCESS;
    execinfo.lpFile = FileName;
    execinfo.lpParameters = Parameters;
    execinfo.lpVerb = "open";
    execinfo.nShow = SW_SHOWDEFAULT;
    ::ShellExecuteEx(&execinfo);
}

void executeProgram(std::string & e, std::string & o) {
    executeProgram( e.c_str(), o.c_str() );
}

void underHandler(HWND hwnd) {
    which_corner = 4;

    const int MENU_HEIGHT = ::GetSystemMetrics(SM_CYMENU);
    int screen_height = ::GetSystemMetrics(SM_CYFULLSCREEN);
    screen_height += MENU_HEIGHT;

    ::ShowWindow(hwnd, SW_RESTORE);

    main_x = 0;
    main_y = screen_height - main_height;
    ::MoveWindow(hwnd, main_x, main_y, main_width, main_height, REPAINT);
}
