#include "ModeBatch.h"

int buffer_size, lines, columns, scroll_bar_width;

namespace {
    char VER_TEXT[] = "ver.txt"; // VER > ver.txt
    const char DOT_C = 46; // 2Eh, '.';
    const char GAP_C = 32; // 20h, ' ';
    const int DETERMINED_BY_WINDOWS = 300;
    const int DETERMINED_BY_WINDOWS_10 = 9001;
    const int LONG_WINDOW = 30; // Windows 10
    const int MAXIMUM_BUFFER_SIZE = 9999;
    const int MAXIMUM_WIDTH = 120;
    const int MINIMUM_WIDTH = 15;
    const int MS_DOS = 0;
    const int NOT_CONVERTED = -1;
    const int SHORT_WINDOW = 5; // lines
    const int STANDARD_LINE_COUNT = 25;
    const int STANDARD_WIDTH = 80;
    const int VER_TEXT_SIZE = 46;
    const int WINDOWS_10 = 100;
    const int WINDOWS_7 = 61;
    const int WINDOWS_XP = 51;
    const int WINDOWS_VISTA = 60;
    const std::string MODE_CON_BATCH = "C:\\ColonYen\\MODE_CON.bat";
    int delta_x = 8;
    int delta_y = 18;
    int horizontal[H_SIZE] = { 0, 3, 6, 9, 12, 16, 19, 22, 25, 28, 32, 35, 38, 41, 44, 48, 51, 54, 57, 60, 64, 67, 70, 73, 76, 80, 80, 80, 80, 80, 80 };
    int longer = 0; // Windows XP, Windows Vista, Windows 7
    int OS_ID[11][10];
    int version_of_OS = MS_DOS;
    int window_height = 492;
    int window_width = 677;
}

int classicalConsole(int d) {
    using namespace std;

    int e = (window_height - 58) / d + 1;

    if( buffer_size < SHORT_WINDOW ) {
        buffer_size = SHORT_WINDOW;
    } else if( MAXIMUM_BUFFER_SIZE < buffer_size ) {
        buffer_size = MAXIMUM_BUFFER_SIZE;
    }

    if( buffer_size <= e ) {
        scroll_bar_width = 0;
    } else {
        scroll_bar_width = 18;
    }

    lines = buffer_size;
    columns = ( window_width - scroll_bar_width - 18 ) / delta_x;
    if( columns < MINIMUM_WIDTH ) {
        columns = MINIMUM_WIDTH;
    } else if( STANDARD_WIDTH < columns ) {
        columns = STANDARD_WIDTH;
    }

// Producing MODE_CON_BATCH
    ofstream batchFile( MODE_CON_BATCH.c_str() );
    batchFile << "MODE CON: COLS=" << columns << " LINES=" << lines << endl;

    return e;
}

int classicalRectangle(int n) {
    int b = DETERMINED_BY_WINDOWS;

    lines = n;
    window_height = (lines - 1) * delta_y + 58;

    columns = horizontal[n];
    window_width = columns * delta_x + 36;

    return b; // buffer_size
}

int noBufferRectangle(int n) {
    int b = n;

    lines = n;
    window_height = (lines - 1) * delta_y + 58;

    columns = horizontal[n];
    window_width = columns * delta_x + 18;

    if( version_of_OS == WINDOWS_10 ) {
        window_width -= 3;
        window_height -= 3;
    }

    return b; // buffer_size
}

int widerConsole(int d) {
    using namespace std;

    int e = (window_height - 55) / d + 1;

    if( buffer_size < SHORT_WINDOW ) {
        buffer_size = SHORT_WINDOW;
    } else if( MAXIMUM_BUFFER_SIZE < buffer_size ) {
        buffer_size = MAXIMUM_BUFFER_SIZE;
    }

    if( buffer_size <= e ) {
        scroll_bar_width = 0;
    } else {
        scroll_bar_width = 18;
    }

    lines = buffer_size;
    columns = (window_width - scroll_bar_width - 15) / delta_x;

    if( columns < MINIMUM_WIDTH ) {
        columns = MINIMUM_WIDTH;
    } else if( MAXIMUM_WIDTH < columns ) {
        columns = MAXIMUM_WIDTH;
    }

// Producing MODE_CON_BATCH
    ofstream batchFile( MODE_CON_BATCH.c_str() );
    batchFile << "MODE CON: COLS=" << columns << " LINES=" << lines << endl;

    return e;
}

int widerRectangle(int n) {
    int b = DETERMINED_BY_WINDOWS_10;

    lines = n;
    window_height = (lines - 1) * delta_y + 55;

    columns = horizontal[n];
    window_width = columns * delta_x + 33;

    return b; // buffer_size
}

ProduceBatch::~ProduceBatch() {
}

ProduceBatch::ProduceBatch(int b, int e, int u, int wh, int ww) {
    bar = b;
    edge = e;
    user_defined_size = u;
    window_height = wh;
    window_width = ww;

    OS_ID[0][0] = MS_DOS;
    OS_ID[5][1] = WINDOWS_XP;
    OS_ID[6][0] = WINDOWS_VISTA;
    OS_ID[6][1] = WINDOWS_7;
    OS_ID[10][0] = WINDOWS_10;

	version_of_OS = checkVersion();
    if( version_of_OS == WINDOWS_10 ) {
        int level[H_SIZE] = { 0, 4, 8, 12, 16, 20, 24, 28, 32, 36, 40, 44, 48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96, 100, 104, 108, 112, 116, 120 };

        for(int i = 0; i < H_SIZE; ++i) {
            horizontal[i] = level[i];
        }

        delta_y = 16;
        longer = 5;
    }

}

ProduceBatch::ProduceBatch(int b, int e, int u, int v, int wh, int ww) {
    bar = b;
    edge = e;
    user_defined_size = u;
    version_of_OS = v;
    window_height = wh;
    window_width = ww;

    OS_ID[0][0] = MS_DOS;
    OS_ID[5][1] = WINDOWS_XP;
    OS_ID[6][0] = WINDOWS_VISTA;
    OS_ID[6][1] = WINDOWS_7;
    OS_ID[10][0] = WINDOWS_10;

    if( version_of_OS == WINDOWS_10 ) {
        int level[H_SIZE] = { 0, 4, 8, 12, 16, 20, 24, 28, 32, 36, 40, 44, 48, 52, 56, 60, 64, 68, 72, 76, 80, 84, 88, 92, 96, 100, 104, 108, 112, 116, 120 };

        for(int i = 0; i < H_SIZE; ++i) {
            horizontal[i] = level[i];
        }

        delta_y = 16;
        longer = 5;
    }

}

int ProduceBatch::checkVersion() {
    using namespace std;

    char p[P_SIZE];
    char trace[2];
    int major, minor;
    int v = MS_DOS;

    try {
        ifstream verFile(VER_TEXT);
        verFile.exceptions(ios_base::failbit);
        verFile.getline(p, P_SIZE); // Line-1
        verFile.getline(p, P_SIZE); // Line-2
    } catch(...) {
        char x[7] = "error-C";
        ofstream errorFile("error.txt"); errorFile << "checkVersion() " << x << endl;
        exit(x[6]);
    }

    for(int i = 2; i < VER_TEXT_SIZE; ++i) {
        trace[0] = p[ i - 2 ];
        trace[1] = p[ i - 1 ];

        if( p[i] == DOT_C ) {
            minor = character_to_integer( p[ i + 1 ] );

            if( trace[0] == GAP_C ) {
                major = character_to_integer( trace[1] );
                v = OS_ID[major][minor];
            } else {
                major = character_to_integer( trace[0] );
                major = 10 * major + character_to_integer( trace[1] );
                v = OS_ID[major][minor];
            }

            break;
        }

    }

    if( v == MS_DOS ) {
        char x[7] = "error-D";
        ofstream errorFile("error.txt"); errorFile << "checkVersion() " << x << endl;
        exit(x[6]);
    }

    return v;
}

int ProduceBatch::character_to_integer(char c) {
    using namespace std;

    int r = NOT_CONVERTED;

    if( '0' <= c && c <= '9' ) {
        r = c - '0';
    } else {
        char x[7] = "error-E";
        ofstream errorFile("error.txt"); errorFile << "character_to_integer() " << x << endl;
        exit(x[6]);
    }

    return r;
}

int ProduceBatch::consoleHeight() {
    console_height = window_height;
    return console_height;
}

int ProduceBatch::consoleWidth() {
    console_width = window_width;
    return console_width;
}

int ProduceBatch::estimated() const {
    return estimate;
}

bool ProduceBatch::setting() {
    bool constant_ratio = false;

    if( version_of_OS == WINDOWS_10 ) {
        preparing_batch = widerConsole;
        similar_rectangle = widerRectangle;
    } else {
        preparing_batch = classicalConsole;
        similar_rectangle = classicalRectangle;
    }

    if( SHORT_WINDOW <= edge && edge <= LONG_WINDOW ) {
// The scroll bar shall disappear.
        similar_rectangle = noBufferRectangle;
        buffer_size = similar_rectangle(edge);
        constant_ratio = true;
    } else {
        if( SHORT_WINDOW <= bar && bar <= LONG_WINDOW ) {
            buffer_size = similar_rectangle(bar);
            constant_ratio = true;
        } else {
            buffer_size = similar_rectangle(STANDARD_LINE_COUNT);
        }

        if( user_defined_size > 0 ) {
            buffer_size = user_defined_size;
        }

    }

// Producing MODE_CON_BATCH
    estimate = preparing_batch(delta_y);
    return constant_ratio;
}

int ProduceBatch::startRectangle(int b) {
    bar = b;

    if( version_of_OS == WINDOWS_10 ) {
        bar += longer;

        preparing_batch = widerConsole;
        similar_rectangle = widerRectangle;
    } else {
        preparing_batch = classicalConsole;
        similar_rectangle = classicalRectangle;
    }

    buffer_size = similar_rectangle(bar);
    estimate = preparing_batch(delta_y);
    return estimate;
}

