#ifndef MODE_BATCH_H
#define MODE_BATCH_H

#define H_SIZE 31
#define P_SIZE 128
#include <fstream>
#include <string>

typedef int (*PreparingBatch)(int d);
typedef int (*SimilarRectangle)(int n);

class ProduceBatch {
    int bar, console_height, console_width, edge, estimate, user_defined_size;
    PreparingBatch preparing_batch;
    SimilarRectangle similar_rectangle;

    int character_to_integer(char c);

public:
    ~ProduceBatch();
    ProduceBatch(int b, int e, int u, int wh, int ww);
    ProduceBatch(int b, int e, int u, int v, int wh, int ww);

    bool setting();
    int checkVersion();
    int consoleHeight();
    int consoleWidth();
    int estimated() const;
    int startRectangle(int b);
};

#endif // MODE_BATCH_H
