#include "Numbered.h"

namespace {
    const int TRIMMING = 1;
    const int FINAL_SIZE_1 = 11; // 10 + 1
    const int FINAL = 2147483647; // 0x7FFFFFFF
//                    1234567890
}

NumberedTerm::~NumberedTerm() {
    delete[] f;
    delete[] ft;
    delete[] p;
    delete[] pt;
    delete[] s;
    delete[] st;
}

NumberedTerm::NumberedTerm(char *a) {
    char *q;
    int size;

    pt = NULL;
    ft = NULL;
    st = NULL;
    trimmed = false;

    final = FINAL;
    length = strlen(a);
    p = new char[ length + 1 ];

// Copying all
    strcpy(p, a);
    span = strspn( strrev(p), "0123456789");
    non_number_length = length - span;

// Copying the second part of a
    size = span + 1;
    s = new char[size];

    q = & a[non_number_length];
    memcpy(s, q, span);
    s[span] = '\0';

// Copying the first part of a
    size = non_number_length + 1;
    f = new char[size];

    memcpy(f, a, non_number_length);
    f[non_number_length] = '\0';
}

NumberedTerm::NumberedTerm(char *a, int less_than_FINAL) {
    char *q;
    int size;

    pt = NULL;
    ft = NULL;
    st = NULL;
    trimmed = false;

    final = less_than_FINAL;
    length = strlen(a);
    p = new char[ length + 1 ];

// Copying all
    strcpy(p, a);
    span = strspn( strrev(p), "0123456789");
    non_number_length = length - span;

// Copying the second part of a
    size = span + 1;
    s = new char[size];

    q = & a[non_number_length];
    memcpy(s, q, span);
    s[span] = '\0';

// Copying the first part of a
    size = non_number_length + 1;
    f = new char[size];

    memcpy(f, a, non_number_length);
    f[non_number_length] = '\0';
}

NumberedTerm::NumberedTerm(std::string & argument) {
    char *q;
    char a[FINAL_SIZE_1];
    int size;

    memset(a, 0, FINAL_SIZE_1);
    strncpy(a, argument.c_str(), FINAL_SIZE_1 - 1 );

    pt = NULL;
    ft = NULL;
    st = NULL;
    trimmed = false;

    final = FINAL;
    length = strlen(a);
    p = new char[ length + 1 ];

// Copying all
    strcpy(p, a);
    span = strspn( strrev(p), "0123456789");
    non_number_length = length - span;

// Copying the second part of a
    size = span + 1;
    s = new char[size];

    q = & a[non_number_length];
    memcpy(s, q, span);
    s[span] = '\0';

// Copying the first part of a
    size = non_number_length + 1;
    f = new char[size];

    memcpy(f, a, non_number_length);
    f[non_number_length] = '\0';
}

NumberedTerm::NumberedTerm(std::string & argument, int less_than_FINAL) {
    char *q;
    char a[FINAL_SIZE_1];
    int size;

    memset(a, 0, FINAL_SIZE_1);
    strncpy(a, argument.c_str(), FINAL_SIZE_1 - 1 );

    pt = NULL;
    ft = NULL;
    st = NULL;
    trimmed = false;

    final = less_than_FINAL;
    length = strlen(a);
    p = new char[ length + 1 ];

// Copying all
    strcpy(p, a);
    span = strspn( strrev(p), "0123456789");
    non_number_length = length - span;

// Copying the second part of a
    size = span + 1;
    s = new char[size];

    q = & a[non_number_length];
    memcpy(s, q, span);
    s[span] = '\0';

// Copying the first part of a
    size = non_number_length + 1;
    f = new char[size];

    memcpy(f, a, non_number_length);
    f[non_number_length] = '\0';
}

bool NumberedTerm::trimmedSequence() {
    char *q;
    int size, u;
/*
a: -i1-37
first part of a: -i1-
second part of a: 37
trimmed sequence: -i1
first part of trimmed sequence: -i
second part of trimmed sequence: 1
*/

// Trimming the first part of a
    trimmed_sequence_length = strlen(f) - TRIMMING;
    pt = new char[ trimmed_sequence_length + 1 ];
    memcpy(pt, f, trimmed_sequence_length);
    pt[trimmed_sequence_length] = '\0';
    u = strspn( strrev(pt), "0123456789");
    if(u == 0) {
        if(final == FINAL) {
            trimmed = false;
        } else {   // interval of 1 to 2147483646, for example
            st = new char[FINAL_SIZE_1];
            strcpy(st, s);

            size = strlen(f);
            ft = new char[ size + 1 ];
            strcpy(ft, f);

            sprintf(s, "%d", final);

            trimmed = true;
      }

    } else {
        span = u;
        non_number_length = trimmed_sequence_length - span;

// Copying the second part of trimmed sequence
        size = span + 1;
        st = new char[size];

        q = & f[non_number_length];
        memcpy(st, q, span);
        st[span] = '\0';

// Copying the first part of trimmed sequence
        size = non_number_length + 1;
        ft = new char[size];

        q = & f[0];
        memcpy(ft, q, non_number_length);
        ft[non_number_length] = '\0';

        trimmed = true;
    }

    return trimmed;
}

int NumberedTerm::number() {
    using namespace std;

    string sequence(s);
    stringstream ss(sequence);
    int n;
    ss >> n;
    return n;
}

int NumberedTerm::subnumber() {
    using namespace std;

    int k = -1; // error

    if(trimmed) {
        string sequence(st);
        stringstream ss(sequence);
        ss >> k;
    }

    return k;
}

std::string NumberedTerm::parameter() {
    if(trimmed) {
        std::string first_trimmed(ft);
        return first_trimmed;
    } else {
        std::string first(f);
        return first;
    }

}
